﻿package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import funnel.*;
	import flash.display.MovieClip;

	import funnel.i2c.*;
	/**
	* ...
	* @author Kazushi Mukaiyama
	*/
	public class Main extends Sprite {
		private var fio:Fio;
		//追加
		private var accl:LIS302DL;
		
		private var cx:Number;
		private var cy:Number;
		private var cz:Number;
		private var px:Number;
		private var py:Number;
		private var pz:Number;
		
		public function Main() {
			trace("start");
			init();
			addEvents();
		}
		
		private function init():void
		{
			var config:Configuration = Fio.FIRMATA;
			config.setDigitalPinMode(12, IN);
			config.setDigitalPinMode(13, OUT);
			
			// set unused analog pins to digital outputs to save processor time
			config.setDigitalPinMode(15, OUT);	// set A1 as digital output
			config.setDigitalPinMode(16, OUT);	// set A2 as digital output
			config.setDigitalPinMode(17, OUT);	// set A3 as digital output		
			config.setDigitalPinMode(20, OUT);	// set A6 as digital output		
			config.setDigitalPinMode(21, OUT);	// set A7 as digital output		

			fio = new Fio([1], config);
			
			accl = new LIS302DL(fio.ioModule(1));		

			
			anim.gotoAndStop(1);
		}
		
		private function addEvents():void
		{
			fio.addEventListener(FunnelEvent.READY, trace);
			fio.addEventListener(FunnelErrorEvent.REBOOT_ERROR, trace);
			fio.addEventListener(FunnelErrorEvent.CONFIGURATION_ERROR, trace);
			fio.addEventListener(FunnelErrorEvent.ERROR, trace);
			
			// ループ
			this.addEventListener(Event.ENTER_FRAME, enterFrame);
		}
		
		private function enterFrame(e:Event):void 
		{
			cx = accl.x;
			cy = accl.y;
			cz = accl.z;
			
			//値
			//trace("x"+Math.abs(px - cx)+": y" + Math.abs(py - cy)+": z" + Math.abs(pz - cz));
			
			//yの値が大きく変わったとき
			if (Math.abs(py - cy) > 0.9) {
				trace("戻る");
				anim.gotoAndStop(1);
			}
				
			//打ち出の小槌
			if (Math.abs(px - cx) > 0.8 && Math.abs(pz - cz) > 0.2) {
				trace("POM!!");
				anim.gotoAndPlay(2);
			}
			
			px = cx;
			py = cy;
			pz = cz;
			
		}
	}
}